
#include "Definitions.h"

#ifndef   EXEC_TYPES_H
#include <exec/types.h>
#endif /* EXEC_TYPES_H */

#ifndef   STDLIB_H
#include <stdlib.h>
#endif /* STDLIB_H */

#ifndef   STRING_H
#include <string.h>
#endif /* STRING_H */

#define MAXLINELEN 256
#define PATHSIZE   256

Prototype char	*strrep (char *old, const char *new);
Prototype char	*ltostr (long);

/* file support functions */
#ifdef _STDIO_H
Prototype int	 std_writefile (int (*writefunc)(FILE *, APTR), APTR);
#endif
Prototype UBYTE  pattern[];
Prototype void	 splitpath (char *, char *, char *);
Prototype int	 getappname (char *, int);
#ifdef DOS_DOS_H
Prototype BOOL	 getpathto (BPTR, char *, char *);
#endif

Prototype void format_string (char *, const char *);

/* command interface */
Prototype UBYTE *av[];
Prototype UBYTE  tmp_buffer[MAXLINELEN];
Prototype void	 error (char * fmt, ...);
Prototype int	 buffered_do_command (const char *);
Prototype int	 do_command	     (char *);
Prototype void	 set_Abortion (int);
Prototype int	 is_Aborted   (void);
Prototype void	 no_Memory    (void);
Prototype int	 breakcheck   (void);
Prototype void	clearbreaks   (void);
Prototype char	*GetTypedVar (const char *, int *);
Prototype int	 SetTypedVar (const char *, const char *, int );

#define RET_FAIL    0
#define RET_SUCC    1

#define VAR_NEX     0
#define VAR_SV	    1

#define NEW(x) ((x) = malloc(sizeof (*(x))))
#define DISPOSE(x) free(x)


#ifdef INTUITION_INTUITION_H
extern struct Window *active_window	(void);
extern void	      closesharedwindow (struct Window *);
#endif

#define SET_ABORTION set_Abortion
#define IS_ABORTED   is_Aborted
#define nomemory()   no_Memory()

extern int NodeNodeComparison();
extern int NodeStringComparison();

